'From VisualWorks® NonCommercial, Release 7 of June 14, 2002 on June 10, 2003 at 10:17:19 am'!


CormasNS.Models defineNameSpace: #JLB
	private: false
	imports: '
			private Smalltalk.*
			private CormasNS.Kernel.*
			'
	category: 'JLBCategory'!


CormasNS.Models.JLB defineClass: #WoodLand
	superclass: #{CormasNS.Kernel.SpatialEntityAggregate}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.WoodLand defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.WoodLand class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.WoodLand methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.JLB.WoodLand methodsFor: 'pov'!

pov
 ^#forest! !


CormasNS.Models.JLB defineClass: #Community
	superclass: #{CormasNS.Kernel.Group}
	indexedType: #none
	private: false
	instanceVariableNames: 'threshold forests '
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.Community defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Community class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Community methodsFor: 'init'!

init
	super init.
	threshold := 0!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.JLB.Community methodsFor: 'control'!

markForests
	self forests do: [:aForest | aForest components size < self threshold
			ifTrue: [aForest components do: [:aCell | aCell mark: aForest components size]]
			ifFalse: [aForest components do: [:aCell | aCell mark: 0]]]!

step
	"Update its thresshold then mark the forests. Called every 10 years"
	self updateThreshold.
	self markForests!

updateThreshold
	| sumOfThresolds |
	self components isEmpty ifTrue:[^0].
	sumOfThresolds := self components inject: 0 into: [:cumul :a | cumul + a threshold].
	self threshold: sumOfThresolds / self components size! !

!CormasNS.Models.JLB.Community methodsFor: 'accessing'!

forests
	^forests!

forests: x
	forests := x!

threshold
	^threshold!

threshold: k
	threshold := k! !


CormasNS.Models.JLB defineClass: #Strategy
	superclass: #{CormasNS.Kernel.PassiveObject}
	indexedType: #none
	private: false
	instanceVariableNames: 'holder '
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.Strategy defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Strategy class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Strategy methodsFor: 'init'!

init
	super init.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.JLB.Strategy methodsFor: 'control'!

decideActions: targetCells 
	targetCells isEmpty
		ifTrue: [self holder randomWalk]
		ifFalse: 
			[self holder moveTo: (Cormas selectRandomlyFrom: targetCells).
			self holder cutForest]!

determineTargets: visibleCells
"^ <OrderedCollection of: Cell>
visibleCells = <OrderedCollection of: Cell>"
	self subclassResponsibility!

process: perceiveCells
| targets |
	targets := self determineTargets: perceiveCells.
	self decideActions: targets! !

!CormasNS.Models.JLB.Strategy methodsFor: 'accessing'!

holder
	^holder!

holder: aShepherd
	holder := aShepherd! !


CormasNS.Models.JLB defineClass: #CollectiveStrategy
	superclass: #{CormasNS.Models.JLB.Strategy}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.CollectiveStrategy defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.CollectiveStrategy class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.CollectiveStrategy methodsFor: 'init'!

init
	super init.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.JLB.CollectiveStrategy methodsFor: 'action'!

determineTargets: visibleCells
"^ <OrderedCollection of: Cell>
visibleCells = <OrderedCollection of: Cell>"

	^visibleCells select: [:aCell | aCell mark = 0]! !


CormasNS.Models.JLB defineClass: #Cell
	superclass: #{CormasNS.Kernel.SpatialEntityElement}
	indexedType: #none
	private: false
	instanceVariableNames: 'forest mark '
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.Cell defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Cell class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

!CormasNS.Models.JLB.Cell class methodsFor: 'constants'!

proba
	^0.0025! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Cell methodsFor: 'pov'!

pov
	(self forest notNil and: [self forest])
		ifTrue: [^#forest]
		ifFalse: [^#grazing]! !

!CormasNS.Models.JLB.Cell methodsFor: 'accessing'!

forest
	^forest!

forest: x
	forest := x.
	self defineVisualState; show!

mark
	"Getter accessor with default value = 0 "
	mark isNil ifTrue:[mark := 0]. 
	
	^mark!

mark: anObject 
	mark := anObject! !

!CormasNS.Models.JLB.Cell methodsFor: 'dynamics'!

forestRecover
	| nbFN |
	self forest
		ifFalse: 
			[nbFN := (self neighbourhood select: [:c | c forest]) size.
			Cormas random < (Cell proba * nbFN) ifTrue: [self forest: true]]! !

!CormasNS.Models.JLB.Cell methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !


CormasNS.Models.JLB defineClass: #Shepherd
	superclass: #{CormasNS.Kernel.AgentLocation}
	indexedType: #none
	private: false
	instanceVariableNames: 'community currentStrategy threshold forestMemory '
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.Shepherd defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Shepherd class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.Shepherd methodsFor: 'init'!

init
	super init.
	self forestMemory: 0.
	self threshold: 0.
	self updateStrategy!

initId
	self id: (self class CurrentId: self class CurrentId + 1)!

updateStrategy
 self currentStrategy: (Cormas selectRandomlyFrom: self knownStrategies) new! !

!CormasNS.Models.JLB.Shepherd methodsFor: 'action'!

cutForest
	self patch forest: false! !

!CormasNS.Models.JLB.Shepherd methodsFor: 'control'!

step
	self updateForestMemory.
	self currentStrategy process: self visibleCells!

updateForestMemory
	(self visibleCells contains: [:c | c forest])
		ifTrue: [self forestMemory: self forestMemory + 1]!

updateThreshold: periodicity
	self threshold: periodicity - self forestMemory.
	self forestMemory: 0! !

!CormasNS.Models.JLB.Shepherd methodsFor: 'perception'!

visibleCells
	^self perception: 1! !

!CormasNS.Models.JLB.Shepherd methodsFor: 'accessing'!

community
	^community!

community: v
	community := v!

currentStrategy
	^currentStrategy!

currentStrategy: aStrategy 
	currentStrategy := aStrategy.
	aStrategy holder: self!

forestMemory
	^forestMemory!

forestMemory: x 
	forestMemory := x!

knownStrategies
	^Strategy subclasses!

threshold
	^threshold!

threshold: x 
	threshold := x! !

!CormasNS.Models.JLB.Shepherd methodsFor: 'pov'!

pov
	^self currentStrategy class name! !


CormasNS.Models.JLB defineClass: #JLB
	superclass: #{CormasNS.Kernel.CormasModel}
	indexedType: #none
	private: false
	instanceVariableNames: 'theCells theWoodLands theShepherds theStrategys theCommunitys theIntermediateStrategys theIndividualStrategys theCollectiveStrategys nbShepherds '
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.JLB class methodsFor: 'description'!

aboutIt
| txt |
	txt := 
'This model has been rewrited from the article of J.L. Bonnefoy*.
Please visite the Cormas web site :  http://cormas.cirad.fr/en/applica/jlb.htm

* Bonnefoy, J.-L., Le Page, C., Rouchier, J. et Bousquet, F., 2000. Modelling spatial practices and social representations of space using multi-agents. p. 155-168 in: G. Ballot et G. Weisbuch (eds), Application of simulation to social science. Hermès, Paris


' asText.
	ComposedTextView open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 800 @ 150!

howToRunIt
| txt |
	txt := 'Just select the init and step methods' asText emphasizeAllWith: #(#bold).
	ComposedTextView open: txt asValue
		label: 'How to run ' , self name , '     step-by-step instructions'
		icon: (Icon constantNamed: #workspace)
		extent: 200 @ 50! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.JLB methodsFor: 'instance-creation'!

buildForests
	self spaceModel
		setAggregatesFrom: Cell
		verifying: [:c | c forest]
		into: WoodLand.!

createForests
	| seed |
	10 timesRepeat: 
			[seed := Cormas selectRandomlyFrom: (self theCells select: [:c | c forest not]).
			seed forest: true.
			(seed recursiveNeighbourhood: (Cormas randomFrom: 1 to: 5))
				do: [:a | a forest: true]]!

initAgents
	| s |
	super initAgents.
	self theCommunitys add: Community new init.
	1 to: self nbShepherds
		do: 
			[:i | 
			s := Shepherd new.
			s init.
			s community: self theCommunity.
			self theShepherds add: s.
			s moveTo: (Cormas selectRandomlyFrom: self theCells)].
	self theCommunity addComponents: self theShepherds.
	self theCommunity forests: self theWoodLands! !

!CormasNS.Models.JLB.JLB methodsFor: 'init'!

init
	"self spaceModel loadEnvironmentFromFile: ((Cormas mapsPath: 'JLB') construct: 'test.env')."
	self spaceModel loadEnvironmentFromFile: 'test.env'.
	self buildForests.
	self periodicity: 10.
	self initAgents! !

!CormasNS.Models.JLB.JLB methodsFor: 'control'!

step: t 
	self theShepherds do: [:a | a step].
	self theCells do: [:a | a forestRecover].
	self testPeriod
		ifTrue: 
			[self buildForests.
			self theShepherds do: [:a | a updateThreshold: self periodicity].
			self theCommunity step].
	self updateData: t! !

!CormasNS.Models.JLB.JLB methodsFor: 'accessing'!

nbShepherds
"Default value = 40"
	nbShepherds isNil ifTrue:[^40].
	^nbShepherds!

nbShepherds: x
	nbShepherds := x!

periodicity
	^periodicity!

periodicity: x
	periodicity := x!

theCells
^theCells!

theCells: x
theCells := x!

theCollectiveStrategys
^theCollectiveStrategys!

theCollectiveStrategys: x
theCollectiveStrategys := x!

theCommunity
	^theCommunitys first!

theCommunitys
^theCommunitys!

theCommunitys: x
theCommunitys := x!

theIndividualStrategys
^theIndividualStrategys!

theIndividualStrategys: x
theIndividualStrategys := x!

theIntermediateStrategys
^theIntermediateStrategys!

theIntermediateStrategys: x
theIntermediateStrategys := x!

theShepherds
^theShepherds!

theShepherds: x
theShepherds := x!

theStrategys
^theStrategys!

theStrategys: x
theStrategys := x!

theWoodLands
^theWoodLands!

theWoodLands: x
theWoodLands := x! !

!CormasNS.Models.JLB.JLB methodsFor: 'probes'!

nbForestCells
"modify this instruction to calculate the number to be recorded"
^(self theCells select:[:c| c forest]) size!

nbWoodLands
"modify this instruction to calculate the number to be recorded"
^self theWoodLands size!

woodLandsAverageSize
"modify this instruction to calculate the number to be recorded"
^self nbForestCells = 0 ifTrue:[0] ifFalse:[self nbWoodLands / self nbForestCells]! !


CormasNS.Models.JLB defineClass: #IntermediateStrategy
	superclass: #{CormasNS.Models.JLB.Strategy}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.IntermediateStrategy defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.IntermediateStrategy class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.IntermediateStrategy methodsFor: 'init'!

init
	super init.!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CormasNS.Models.JLB.IntermediateStrategy methodsFor: 'action'!

determineTargets: visibleCells 
	"^ <OrderedCollection of: Cell> 
	visibleCells = <OrderedCollection of: Cell>"

	| collec |
	collec := visibleCells select: [:aCell | aCell mark = 0].
	collec isEmpty ifTrue: [collec := visibleCells select: [:aCell | aCell mark >= (self holder threshold + self holder community threshold / 2)]].
	^collec! !


CormasNS.Models.JLB defineClass: #IndividualStrategy
	superclass: #{CormasNS.Models.JLB.Strategy}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'JLBCategory'!

CormasNS.Models.JLB.IndividualStrategy defineSharedVariable: #CurrentId
	private: false
	constant: false
	category: 'As yet unclassified'
	initializer: nil!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.IndividualStrategy class methodsFor: 'id'!

CurrentId
	^CurrentId isNil 
		ifTrue: [0] 
		ifFalse: [CurrentId]!

CurrentId: x
	^CurrentId := x! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!


!CormasNS.Models.JLB.IndividualStrategy methodsFor: 'action'!

determineTargets: visibleCells 
	"^ <OrderedCollection of: Cell> 
	visibleCells = <OrderedCollection of: Cell>"

	| collec |
	collec := visibleCells select: [:aCell | aCell mark = 0].
	collec isEmpty ifTrue: [collec := visibleCells select: [:aCell | aCell mark >= self holder threshold]].
	^collec! !

!CormasNS.Models.JLB.IndividualStrategy methodsFor: 'init'!

initId
	self id: (self class CurrentId: self class CurrentId + 1)! !


